'use strict';(function(window){var gL10nData={};var gTextData='';var gLanguage='';function evalString(text){return text.replace(/\\\\/g,'\\').replace(/\\n/g,'\n').replace(/\\r/g,'\r').replace(/\\t/g,'\t').replace(/\\b/g,'\b').replace(/\\f/g,'\f').replace(/\\{/g,'{').replace(/\\}/g,'}').replace(/\\"/g,'"').replace(/\\'/g,"'");}
function parseProperties(text,lang){var reBlank=/^\s*|\s*$/;var reComment=/^\s*#|^\s*$/;var reSection=/^\s*\[(.*)\]\s*$/;var reImport=/^\s*@import\s+url\((.*)\)\s*$/i;var currentLang='*';var supportedLang=[];var skipLang=false;var data=[];var match='';var entries=text.replace(reBlank,'').split(/[\r\n]+/);for(var i=0;i<entries.length;i++){var line=entries[i];if(reComment.test(line))
continue;if(reSection.test(line)){match=reSection.exec(line);currentLang=match[1];skipLang=(currentLang!=lang)&&(currentLang!='*')&&(currentLang!=lang.substring(0,2));continue;}else if(skipLang){continue;}
if(reImport.test(line)){match=reImport.exec(line);}
var tmp=line.split('=');if(tmp.length>1)
data[tmp[0]]=evalString(tmp[1]);}
for(var key in data){var id,prop,index=key.lastIndexOf('.');if(index>0){id=key.substring(0,index);prop=key.substr(index+1);}else{id=key;prop='textContent';}
if(!gL10nData[id])
gL10nData[id]={};gL10nData[id][prop]=data[key];}}
function parse(text,lang){gTextData+=text;return parseProperties(text,lang);}
function loadResource(href,lang,onSuccess,onFailure){var xhr=new XMLHttpRequest();xhr.open('GET',href,true);xhr.overrideMimeType('text/plain; charset=utf-8');xhr.onreadystatechange=function(){if(xhr.readyState==4){if(xhr.status==200||xhr.status==0){parse(xhr.responseText,lang);if(onSuccess)
onSuccess();}else{if(onFailure)
onFailure();}}};xhr.send(null);}
function loadLocale(lang,callback){clear();var langLinks=document.querySelectorAll('link[type="application/l10n"]');var langLinksCount=langLinks.length;var langScripts=document.querySelectorAll('script[type="application/l10n"]');var langScriptCount=langScripts.length;var langCount=langLinksCount+langScriptCount;var onResourceLoaded=null;var gResourceCount=0;onResourceLoaded=function(){gResourceCount++;if(gResourceCount>=langCount){if(callback)
callback();var evtObject=document.createEvent('Event');evtObject.initEvent('localized',false,false);evtObject.language=lang;window.dispatchEvent(evtObject);}}
function l10nResourceLink(link){var href=link.href;var type=link.type;this.load=function(lang,callback){var applied=lang;loadResource(href,lang,callback,function(){console.warn(href+' not found.');applied='';});return applied;};}
gLanguage=lang;for(var i=0;i<langLinksCount;i++){var resource=new l10nResourceLink(langLinks[i]);var rv=resource.load(lang,onResourceLoaded);if(rv!=lang)
gLanguage='';}
for(var i=0;i<langScriptCount;i++){var scriptText=langScripts[i].text;parse(scriptText,lang);onResourceLoaded();}}
function getL10nData(key){var data=gL10nData[key];if(!data)
console.warn('[l10n] #'+key+' missing for ['+gLanguage+']');return data;}
function substArguments(str,args){var reArgs=/\{\{\s*([a-zA-Z\.]+)\s*\}\}/;var match=reArgs.exec(str);while(match){if(!match||match.length<2)
return str;var arg=match[1];var sub='';if(arg in args){sub=args[arg];}else if(arg in gL10nData){sub=gL10nData[arg].textContent;}else{console.warn('[l10n] could not find argument {{'+arg+'}}');return str;}
str=str.substring(0,match.index)+sub+
str.substr(match.index+match[0].length);match=reArgs.exec(str);}
return str;}
function translateString(key,args,fallback){var data=getL10nData(key);if(!data&&fallback)
data={textContent:fallback};if(!data)
return'{{'+key+'}}';return substArguments(data.textContent,args);}
function translateElement(element){if(!element||!element.dataset)
return;var key=element.dataset.l10nId;var data=getL10nData(key);if(!data)
return;var args;if(element.dataset.l10nArgs)try{args=JSON.parse(element.dataset.l10nArgs);}catch(e){console.warn('[l10n] could not parse arguments for #'+key+'');}
for(var k in data)
element[k]=substArguments(data[k],args);}
function translateFragment(element){element=element||document.querySelector('html');var children=element.querySelectorAll('*[data-l10n-id]');var elementCount=children.length;for(var i=0;i<elementCount;i++)
translateElement(children[i]);if(element.dataset.l10nId)
translateElement(element);}
function clear(){gL10nData={};gTextData='';gLanguage='';}
document.mozL10n={get:translateString,get language(){return{get code(){return gLanguage;},set code(lang){loadLocale(lang,translateFragment);},get direction(){var rtlList=['ar','he','fa','ps','ur'];return(rtlList.indexOf(gLanguage)>=0)?'rtl':'ltr';}};}};})(this);